\name{rareMETALS-package}
\alias{rareMETALS-package}
\alias{rareMETALS}
\docType{package}
\title{
  RareMETALS is an R-package for meta-analysis of gene-level rare
  variant associations tests.
}
\description{
  RareMETALS performs meta-analysis of gene-level associations. It
  builds on the insight that most popular gene-level association tests
  can be constructed using single variant score statistics as well as
  their covariance matrix. Through sharing these summary level data,
  meta-analysis can be performed centrally, which supports a variety of
  rare variant test, such as simple burden test, sequence kernel
  association test, and variable threshold test etc.

  It can also support empirical evaluation of p-values via resampling
  based parametric bootstrap method, as well as conditional analysis,
  which can be useful for dissecting independent association signals.
}
\details{
\tabular{ll}{
  Package: \tab rareMETALS\cr
  Type: \tab Package\cr
  Version: \tab 2.2\cr
  Date: \tab 2013-03-08\cr
  License: \tab GPL-3\cr
}
}
\author{
  Dajiang J. Liu
  Maintainer: Dajiang J. Liu <dajiang@umich.edu>
}
\references{
Liu DJ et al Meta-analysis of Gene-level Associations, submitted, 2013
}
\keyword{ package }
\seealso{
}
\examples{
}
